=== third-party/fastlz/CMakeLists.txt ===
add_library(fastlz STATIC src/fastlz.c)
