=== debian/changelog ===
hhvm (3.24.7+dfsg-2ubuntu6) disco; urgency=medium

  * No-change rebuild for icu soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 13 Nov 2018 08:13:31 +0000

hhvm (3.24.7+dfsg-2ubuntu5) cosmic; urgency=medium

  * No-change rebuild against imagemagick.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Fri, 10 Aug 2018 18:21:50 -0500

hhvm (3.24.7+dfsg-2ubuntu4) cosmic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 15:18:59 +0200

hhvm (3.24.7+dfsg-2ubuntu3) cosmic; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 04 Jun 2018 12:19:48 +0200

hhvm (3.24.7+dfsg-2ubuntu2) cosmic; urgency=medium

  * Try to fix the build on ppc64el.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 15 May 2018 21:12:41 +0000

hhvm (3.24.7+dfsg-2ubuntu1) cosmic; urgency=medium

  * Build on arm64 and ppc64el.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 14 May 2018 18:29:14 +0000

hhvm (3.24.7+dfsg-2) unstable; urgency=medium

  * Correctly remove libsqlite3-3.23.01.patch (Closes: #898404)

 -- Moritz Muehlenhoff <jmm@debian.org>  Mon, 14 May 2018 10:14:50 +0200

hhvm (3.24.7+dfsg-1) unstable; urgency=medium

  * New upstream release
    - Drop gcc-7.patch (obsolete with upstream changes, now supported)
    - Drop reproducible-hack-hhi.patch (obsolete with upstream
      changes, reproducibility needs to be revisited with the
      new upstream release)
    - Drop drop-xlocale.patch (merged upstream)
    - Refreshed remove-broken-json-test.patch (still unfixed upstream)
    - Supports libonig 6.8 (Closes: #897250)
  * Now supports OpenSSL 1.1 (Closes: #858927)
    - Re-enable IMAP extension
  * New upstream addresses CVE-2018-6332, CVE-2018-6334 (Closes: #895194),
    CVE-2018-6335 and CVE-2018-5711
  * Remove Alioth git references, going away soon
  * Switch to debhelper compat level 10
  * Switch priority of hhvm-dbg and hhvm-dev to optional
  * lists.alioth.debian.org is going away, so set myself to Maintainer:
    and Faidon to Uploaders field until a new solution is found

 -- Moritz Muehlenhoff <jmm@debian.org>  Wed, 09 May 2018 10:34:54 +0200
